import adonthell

# -- print inventories
def list (inventories):
    for inv in inventories:
        slot = inv.first ()
        num = 0
        while slot != None:
            num = num + 1
            if slot.count () == 0: print "Slot %i empty" % num
            else: print "Slot %i contains %i items (%s)" % (num, slot.count (), slot.get_item ().name ())
            slot = inv.next ()
        print "-------------------"

# -- move items around
def move (i1, i2, pos, count):
    slot = i1.first ()
    while pos > 1:
        pos = pos - 1
        slot = i1.next ()

    item = slot.get_item ()
    if item != None:
        print "Moving %s (%i) ..." % (item.name (), count)
        i2.add (item, count)
    
    
# -- initialize event handler and gametime subsystems
adonthell.event_handler_init ()
adonthell.gametime_init (20)

# -- create some mutable items:
print "Creating mutable items ..."

Torch1 = adonthell.item_base (1)
Torch1.load ("small_torch.item")
Torch1.thisown = 0
Torch2 = adonthell.item_base (1)
Torch2.load ("small_torch.item")
Torch2.thisown = 0
Torch3 = adonthell.item_base (1)
Torch3.load ("small_torch.item")
Torch3.thisown = 0
Torch4 = adonthell.item_base (1)
Torch4.load ("small_torch.item")
Torch4.thisown = 0
Torch5 = adonthell.item_base (1)
Torch5.load ("small_torch.item")
Torch5.thisown = 0
Torch6 = adonthell.item_base (1)
Torch6.load ("small_torch.item")
Torch6.thisown = 0
Torch7 = adonthell.item_base (1)
Torch7.load ("small_torch.item")
Torch7.thisown = 0

# -- create an immutable item:
print "creating immutable items ..."

Coin = adonthell.item_base (0)
Coin.load ("coin.item")
Coin.thisown = 0
adonthell.item_storage_add (Coin)

# -- create some inventories:
print "creating inventories ..."

A = adonthell.inventory (1, 5)
B = adonthell.inventory (1, 5)
C = adonthell.inventory (0)

# -- populate inventories
print "populating inventories ..."

A.add (Coin, 3500)
A.add (Torch1)

B.add (Torch2)
B.add (Torch3)
B.add (Coin, 2100)
B.add (Torch4)
B.add (Torch5)

C.add (Coin, 5000)
C.add (Torch6)
C.add (Torch7)

# -- tests
list ([A, B, C])

print "Saving ..."
file = adonthell.ogzstream ()
file.open ("inventory.data")
A.put_state (file)
B.put_state (file)
C.put_state (file)
file.close ()

print "Cleaning up ..."
del A
del B
del C

A = adonthell.inventory ()
B = adonthell.inventory ()
C = adonthell.inventory ()

print "Loading ..."
file = adonthell.igzstream ()
file.open ("inventory.data")
A.get_state (file)
B.get_state (file)
C.get_state (file)
file.close ()

list ([A, B, C])

print "Moving some stuff around ..."
move (C, A, 6, 2)
move (C, A, 1, 55)
move (C, C, 5, 100)
move (A, A, 5, 4)
list([A, C])

print "Saving ..."
file = adonthell.ogzstream ()
file.open ("inventory.data")
A.put_state (file)
B.put_state (file)
C.put_state (file)
file.close ()

print "Cleaning up ..."
del A
del B
del C

A = adonthell.inventory ()
B = adonthell.inventory ()
C = adonthell.inventory ()

print "Loading ..."
file = adonthell.igzstream ()
file.open ("inventory.data")
A.get_state (file)
B.get_state (file)
C.get_state (file)
file.close ()

list([A, C])

print "Moving some stuff around ..."
move (C, B, 1, 1000)

list ([B, C])

# -- cleanup
adonthell.item_storage_cleanup ()